#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1900four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 1900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1900four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four19004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2four19004xi = {
                1:'1017x-362y1562z',
                2:'1025x-1578y259z',
                3:'1040x-804y1370z',
                4:'1050x-313y1552z',
                5:'1054x-1121y1113z',
                6:'1080x-261y1540z',
                7:'1092x-756y1357z',
                8:'1107x-1524y241z',
                9:'1107x-207y1529z',
                10:'1120x-1072y1097z',
                11:'112x-86y1894z',
                12:'1131x-151y1518z',
                13:'1142x-705y1344z',
                14:'1153x-93y1506z',
                15:'1171x-33y1495z',
                16:'1183x-1019y1082z',
                17:'1187x-1466y222z',
                18:'1189x-651y1330z',
                19:'1233x-593y1317z',
                20:'1243x-962y1066z',
                21:'1264x-1403y203z',
                22:'1275x-533y1303z',
                23:'128x-364y1860z',
                24:'1300x-902y1050z',
                25:'1313x-470y1289z',
                26:'132x-90y1893z',
                27:'1337x-1337y184z',
                28:'1348x-404y1275z',
                29:'1354x-838y1034z',
                30:'1380x-336y1261z',
                31:'1406x-1266y165z',
                32:'1406x-771y1018z',
                33:'1408x-266y1247z',
                34:'1432x-193y1232z',
                35:'1453x-119y1218z',
                36:'1453x-701y1002z',
                37:'1469x-43y1203z',
                38:'1472x-1192y146z',
                39:'1497x-627y986z',
                40:'1533x-1114y127z',
                41:'153x-93y1891z',
                42:'154x-374y1856z',
                43:'1590x-1033y108z',
                44:'1618x-581y1021z',
                45:'1643x-948y89z',
                46:'1691x-861y70z',
                47:'1735x-772y51z',
                48:'174x-94y1889z',
                49:'1773x-680y32z',
                50:'1806x-587y13z',
                51:'182x-382y1852z',
                52:'193x-1841y427z',
                53:'196x-93y1887z',
                54:'210x-388y1847z',
                55:'218x-90y1885z',
                56:'240x-392y1843z',
                57:'240x-84y1882z',
                58:'263x-77y1880z',
                59:'271x-394y1838z',
                60:'285x-67y1877z',
                61:'290x-1832y409z',
                62:'302x-394y1833z',
                63:'306x-56y1874z',
                64:'311x-756y1715z',
                65:'327x-42y1871z',
                66:'334x-392y1828z',
                67:'348x-26y1867z',
                68:'357x-754y1706z',
                69:'367x-387y1823z',
                70:'367x-8y1864z',
                71:'386x-1818y390z',
                72:'400x-380y1818z',
                73:'404x-749y1698z',
                74:'433x-370y1812z',
                75:'452x-741y1689z',
                76:'466x-358y1806z',
                77:'482x-1799y372z',
                78:'499x-343y1800z',
                79:'499x-730y1681z',
                80:'507x-1073y1483z',
                81:'532x-326y1794z',
                82:'547x-717y1672z',
                83:'564x-306y1788z',
                84:'569x-1058y1471z',
                85:'576x-1775y353z',
                86:'595x-284y1781z',
                87:'595x-700y1662z',
                88:'626x-259y1774z',
                89:'631x-1039y1459z',
                90:'642x-680y1653z',
                91:'655x-232y1768z',
                92:'670x-1746y334z',
                93:'683x-202y1761z',
                94:'689x-656y1644z',
                95:'693x-1017y1447z',
                96:'701x-1305y1188z',
                97:'710x-170y1753z',
                98:'734x-630y1634z',
                99:'735x-136y1746z',
                100:'754x-990y1434z',
                101:'759x-100y1738z',
                102:'762x-1711y316z',
                103:'775x-1277y1173z',
                104:'779x-601y1624z',
                105:'780x-61y1731z',
                106:'800x-21y1723z',
                107:'814x-960y1422z',
                108:'823x-568y1614z',
                109:'847x-1244y1158z',
                110:'851x-1672y297z',
                111:'865x-533y1604z',
                112:'873x-927y1409z',
                113:'906x-494y1594z',
                114:'918x-1207y1143z',
                115:'931x-889y1396z',
                116:'939x-1627y278z',
                117:'945x-453y1584z',
                118:'96x-1844y446z',
                119:'982x-409y1573z',
                120:'986x-849y1383z',
                121:'987x-1166y1128z'}
#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1900four4xi" usage = "target function for charge19004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1900four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1900FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1900FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1900FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1900FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1900FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four19004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1900FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1900FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1900FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four19004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four19004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1900FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1900FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1900FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1900four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
              
                     